// Forlix SrcDS LogMerge
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2008-2011 Dominik Friedrichs

#include "SrcDS_LogMerge.h"


int main(int argc, char *argv[])
{
  printf(APPVERSION "\n"
         "\n"
         "http://forlix.org/, df@forlix.org\n"
         "Copyright (c) 2008-2011 Dominik Friedrichs\n"
         "\n");

  char loglist[LOGFILE_MAXNUM][SORTSTR_MAXLEN];

  _finddata_t fdata;
  long hfind = _findfirst("l*.log", &fdata);

  if(hfind == -1)
  // no matching files found at all
  {
    printf("No log files matching \"l*.log\" found in current directory\n\n");
    return(0);
  }

  FILE *hlog;
  unsigned int logcnt = 0;

  do
  if(!(fdata.attrib & _A_SUBDIR)
  && (hlog = fopen(fdata.name, "rt")))
  // loop through files matching l*.log
  {
    char line[LINE_MAXLEN];
    line[0] = '\0';

    if(!fdata.size)
    // empty log - delete it
    {
      fclose(hlog);

      if(remove(fdata.name))
        printf("Error deleting empty logfile %s\n", fdata.name);

      continue;
    }

    if(logcnt >= sizeof(loglist)/sizeof(loglist[0]))
    // list overflowed
    {
      printf("Too many logfiles to analyze at once (max %u)\n\n",
             sizeof(loglist)/sizeof(loglist[0]));
      return(1);
    }

    // extract date/time from first line of log
    fgets(line, sizeof(line), hlog);

    char logstr[LOGSTR_MAXLEN];
    logstr[0] = '\0';

    tm tlog;
    if(ReadLogLine(line, &tlog, logstr)
    && strpequ(logstr, "Log file started"))
    // timestamp of first line read and line says "Log file started"
    // add sortstr containing timestamp and filename to loglist
      sprintf(loglist[logcnt++], "%010u_%s", mktime(&tlog), fdata.name);

    fclose(hlog);
  }
  while(_findnext(hfind, &fdata) != -1);
  _findclose(hfind);

  if(!logcnt)
  {
    printf("No log files containing valid data found\n\n");
    return(0);
  }

  // sort the list to merge in the right order
  qsort(loglist, logcnt, sizeof(loglist[0]), loglist_sortcomp);

  if(!MergeLogList(loglist, logcnt))
    return(1);

  printf("Merging complete\n\n");
  return(0);
}
